<?php 
/*
	template name: 游客投稿
	description: template for slmwp.com slmwp theme 
*/
if( isset($_POST['tougao_form']) && $_POST['tougao_form'] == 'send')
{
    global $wpdb;
    $last_post = $wpdb->get_var("SELECT post_date FROM $wpdb->posts WHERE post_type = 'post' ORDER BY post_date DESC LIMIT 1");
 
    // 博客当前最新文章发布时间与要投稿的文章至少间隔120秒。
    // 可自行修改时间间隔，修改下面代码中的120即可
    // 相比Cookie来验证两次投稿的时间差，读数据库的方式更加安全
    if ( current_time('timestamp') - strtotime($last_post) < 120 )
    {
        wp_die('您投稿也太勤快了吧，先歇会儿！');
    }
 
    // 表单变量初始化
    $name = isset( $_POST['tougao_authorname'] ) ? trim(htmlspecialchars($_POST['tougao_authorname'], ENT_QUOTES)) : '';
    $email =  isset( $_POST['tougao_authoremail'] ) ? trim(htmlspecialchars($_POST['tougao_authoremail'], ENT_QUOTES)) : '';
    $blog =  isset( $_POST['tougao_authorblog'] ) ? trim(htmlspecialchars($_POST['tougao_authorblog'], ENT_QUOTES)) : '';
    $title =  isset( $_POST['tougao_title'] ) ? trim(htmlspecialchars($_POST['tougao_title'], ENT_QUOTES)) : '';
    $category =  isset( $_POST['cat'] ) ? (int)$_POST['cat'] : 0;
    $content =  isset( $_POST['tougao_content'] ) ? trim(htmlspecialchars($_POST['tougao_content'], ENT_QUOTES)) : '';
 
    // 表单项数据验证
    if ( empty($name) || mb_strlen($name) > 20 )
    {
        wp_die('昵称必须填写，且长度不得超过20字');
    }
 
    if ( empty($email) || strlen($email) > 60 || !preg_match("/^([a-z0-9\+_\-]+)(\.[a-z0-9\+_\-]+)*@([a-z0-9\-]+\.)+[a-z]{2,6}$/ix", $email))
    {
        wp_die('Email必须填写，且长度不得超过60字，必须符合Email格式');
    }
 
    if ( empty($title) || mb_strlen($title) > 100 )
    {
        wp_die('标题必须填写，且长度不得超过100字');
    }
 
    if ( empty($content) || mb_strlen($content) > 3000 || mb_strlen($content) < 100)
    {
        wp_die('内容必须填写，且长度不得超过3000字，不得少于100字');
    }
 
    $post_content = '昵称: '.$name.'<br />Email: '.$email.'<br />blog: '.$blog.'<br />内容:<br />'.$content;
 
    $tougao = array(
        'post_title' => $title,
        'post_content' => $post_content,
        'post_category' => array($category)
    );
 
 
    // 将文章插入数据库
    $status = wp_insert_post( $tougao );
 
    if ($status != 0) 
    { 
        wp_mail("get_opt('social_mail')","My subject","content");
 
        wp_die('投稿成功！您的文章将在审核通过后发布！','投稿成功！');
    }
    else
    {
        wp_die('投稿失败！');
    }
}
get_header(); ?>
<section id="content">
  <div class="content-nosign">
    <div class="container clearfix">
      <div class="row">
        <div class="col-md-8 bottommargin">
        
          <?php if(have_posts()) : while (have_posts()) : the_post() ?>
          <div class="single-post nobottommargin">
            <div class="entry clearfix">
              
              
              <div class="entry-content notopmargin">
              <div class="entry-title">
                <h2>
                  <?php the_title(); ?>
                </h2>
              </div>
              <div class="divider divider-center"><i class="fa fa-newspaper-o"></i></div>
                <?php the_content(); ?>
                <div class="divider"><i class="fa fa-edit"></i></div>
<form method="post" action="<?php echo $_SERVER["REQUEST_URI"]; ?>">
    <div class="col_half">
        <label for="tougao_authorname">昵称*</label>
        <input type="text" size="40" value="" id="tougao_authorname" name="tougao_authorname" class="required form-control input-block-level"/>
    </div>
 
    <div class="col_half col_last">
        <label for="tougao_authoremail">邮箱*</label>
        <input type="text" size="40" value="" id="tougao_authoremail" name="tougao_authoremail" class="required form-control input-block-level"/>
    </div>
 
    <div class="col_half">
        <label for="tougao_authorblog">您的博客/文章来源</label>
        <input type="text" size="40" value="" id="tougao_authorblog" name="tougao_authorblog" class="required form-control input-block-level" />
        
    </div>
 
    <div class="col_half col_last">
        <label for="tougao_title">文章标题*</label>
        <input type="text" size="40" value="" id="tougao_title" name="tougao_title" class="required form-control input-block-level"/>
    </div>
 
    <div class="col_half">
        <?php wp_dropdown_categories('show_option_none=请选择文章分类&id=tougao-cat&show_count=1&hierarchical=1&hide_empty=0'); ?>
        <label for="tougaocategorg">文章分类*</label>
    </div>
 
    <div class="col_full">
        <textarea rows="15" cols="55" id="tougao_content" name="tougao_content" class="sm-form-control"></textarea>
    </div>
 
    <div class="col_full nobottommargin">
        <input type="hidden" value="send" name="tougao_form" />
        <input type="submit" class="button button-3d button-blue nomargin" value="提交" />
        <input type="reset" class="button button-3d button-black nomargin" value="重填" />
    </div>
</form>
                <?php endwhile; endif; ?>
               
              </div>
            </div>

            
             </div>
        </div>
        <?php get_sidebar(); ?>
      </div>
    </div>
  </div>
</section>
<?php get_footer(); ?>
